Index: typo3/sysext/rtehtmlarea/htmlarea/htmlarea.js
===================================================================
--- typo3/sysext/rtehtmlarea/htmlarea/htmlarea.js	(révision 6908)
+++ typo3/sysext/rtehtmlarea/htmlarea/htmlarea.js	(copie de travail)
@@ -3197,45 +3884,45 @@
 					this.appendToLog("openDialog", "Function " + action + " was not defined when opening dialog for " + buttonId);
 				}
 			}
-				// Window dimensions as per call or button registration
-			var dialogueWindowDimensions = {
-				width:	((dimensions && dimensions.width) ? dimensions.width :
-						(this.editorConfiguration.btnList[buttonId] ? this.editorConfiguration.btnList[buttonId][8].width : 250)),
-				height:	((dimensions && dimensions.height) ? dimensions.height :
-						(this.editorConfiguration.btnList[buttonId] ? this.editorConfiguration.btnList[buttonId][8].height : 250)),
-				top:	((dimensions && dimensions.top) ? dimensions.top :
-						(this.editorConfiguration.btnList[buttonId] ? this.editorConfiguration.btnList[buttonId][8].top : this.editorConfiguration.dialogueWindows.defaultPositionFromTop)),
-				left:	((dimensions && dimensions.left) ? dimensions.left :
-						(this.editorConfiguration.btnList[buttonId] ? this.editorConfiguration.btnList[buttonId][8].left : this.editorConfiguration.dialogueWindows.defaultPositionFromLeft))
-			};
-				// Overrride window dimensions as per PageTSConfig
-			var buttonConfiguration = this.editorConfiguration.buttons[this.editorConfiguration.convertButtonId[buttonId]];
-			if (buttonConfiguration && buttonConfiguration.dialogueWindow) {
-				if (buttonConfiguration.dialogueWindow.width) {
-					dialogueWindowDimensions.width = buttonConfiguration.dialogueWindow.width;
-				}
-				if (buttonConfiguration.dialogueWindow.height) {
-					dialogueWindowDimensions.height = buttonConfiguration.dialogueWindow.height;
-				}
-				if (buttonConfiguration.dialogueWindow.top) {
-					dialogueWindowDimensions.top = buttonConfiguration.dialogueWindow.positionFromTop;
-				}
-				if (buttonConfiguration.dialogueWindow.left) {
-					dialogueWindowDimensions.left = buttonConfiguration.dialogueWindow.positionFromLeft;
-				}
-			}
 			return new HTMLArea.Dialog(
 					this,
 					buttonId,
 					url,
 					actionFunctionReference,
 					arguments,
-					dialogueWindowDimensions,
+					this.getWindowDimensions(dimensions, buttonId),
 					(showScrollbars?showScrollbars:"no"),
 					dialogOpener
 				);
 		}
 	},
+	getWindowDimensions: function (dimensions, buttonId) {
+			// Apply default dimensions
+		var dialogueWindowDimensions = {
+			width: 250,
+			height: 250,
+			top: this.editorConfiguration.dialogueWindows.defaultPositionFromTop,
+			left: this.editorConfiguration.dialogueWindows.defaultPositionFromLeft
+		};
+			// Apply dimensions as per button registration
+		if (this.editorConfiguration.buttonsConfig[buttonId]) {
+			Ext.apply(dialogueWindowDimensions, this.editorConfiguration.buttonsConfig[buttonId].dimensions);
+		}
+			// Apply dimensions as per call
+		Ext.apply(dialogueWindowDimensions, dimensions);
+			// Overrride dimensions as per PageTSConfig
+		var buttonConfiguration = this.editorConfiguration.buttons[this.editorConfiguration.convertButtonId[buttonId]];
+		if (buttonConfiguration && buttonConfiguration.dialogueWindow) {
+			Ext.apply(dialogueWindowDimensions, buttonConfiguration.dialogueWindow);
+			if (buttonConfiguration.dialogueWindow.top) {
+				dialogueWindowDimensions.top = buttonConfiguration.dialogueWindow.positionFromTop;
+			}
+			if (buttonConfiguration.dialogueWindow.left) {
+				dialogueWindowDimensions.left = buttonConfiguration.dialogueWindow.positionFromLeft;
+			}
+		}
+		return dialogueWindowDimensions;
+	},
 
 	/**
 	 * Make url from the name of a popup of the plugin
@@ -3270,6 +3957,100 @@
 	 */
 	appendToLog : function (functionName, text) {
 		HTMLArea._appendToLog("[" + this.name + "::" + functionName + "]: " + text);
+	},
+	/*
+	 * Add a config element to config array if not empty
+	 *
+	 * @param	object		configElement: the config element
+	 * @param	array		configArray: the config array
+	 *
+	 * @return	void
+	 */
+	addConfigElement: function (configElement, configArray) {
+		if (!Ext.isEmpty(configElement)) {
+			configArray.push(configElement);
+		}
+	},
+	/*
+	 * Handler for Ext.TabPanel tabchange event
+	 * Force window ghost height synchronization
+	 * Working around ExtJS 3.1 bug
+	 */
+	syncHeight: function (tabPanel, tab) {
+		var position = this.dialog.getPosition();
+		if (position[0] > 0) {
+			this.dialog.setPosition(position);
+		}
+	},
+	/*
+	 * Show the dialogue window
+	 */
+	show: function () {
+			// Close the window if the editor changes mode
+		this.dialog.mon(this.editor, 'modeChange', this.close, this, {single: true });
+		this.saveSelection();
+		this.dialog.show();
+		this.restoreSelection();
+	},
+	/*
+	 * Close the dialogue window (after saving the selection, if IE)
+	 */
+	close: function () {
+		this.saveSelection();
+		this.dialog.close();
+	},
+	/*
+	 * Dialogue window onClose handler
+	 */
+	onClose: function () {
+		this.restoreSelection();
+	 	this.editor.updateToolbar();
+	},
+	/*
+	 * Handler for window cancel
+	 */
+	onCancel: function () {
+		this.dialog.close();
+	},
+	/*
+	 * Save selection
+	 * Should be called after processing button other than Cancel
+	 */
+	saveSelection: function () {
+			// If IE, save the current selection
+		if (Ext.isIE) {
+			this.bookmark = this.editor.getBookmark(this.editor._createRange(this.editor._getSelection()));
+		}
+	},
+	/*
+	 * Restore selection
+	 * Should be called before processing dialogue button or result
+	 */
+	restoreSelection: function () {
+			// If IE, restore the selection saved when the window was shown
+		if (Ext.isIE) {
+			this.editor.selectRange(this.editor.moveToBookmark(this.bookmark));
+		}
+	},
+	/*
+	 * Build the configuration object of a button
+	 *
+	 * @param	string		button: the text of the button
+	 * @param	function	handler: button handler
+	 * 
+	 * @return	object		the button configuration object
+	 */
+	buildButtonConfig: function (button, handler) {
+		return {
+			xtype: 'button',
+			text: this.localize(button),
+			listeners: {
+				click: {
+					fn: handler,
+					scope: this
+				}
+			}
+		};
 	}
 });
 
@@ -3310,7 +4091,6 @@
 		}
 		HTMLArea.Dialog[this.plugin.name] = this;
 		this.dialogWindow = window.open(url, this.plugin.name + "Dialog", "toolbar=no,location=no,directories=no,menubar=no,resizable=yes,top=" + dimensions.top + ",left=" + dimensions.left + ",dependent=yes,dialog=yes,chrome=no,width=" + dimensions.width + ",height=" + dimensions.height + ",scrollbars=" + showScrollbars);
-
 		if (!this.dialogWindow) {
 			this.plugin.appendToLog("openDialog", "Dialog window could not be opened with url " + url);
 			return false;
@@ -3323,67 +4103,9 @@
 		if (!this.dialogWindow.opener) {
 			this.dialogWindow.opener = this.window;
 		}
-
-		if (!url) this.createForm();
 		return true;
 	},
-
 	/**
-	 * Creates the document and the dialogue form of the dialogue window
-	 *
-	 * @return	void
-	 */
-	createForm : function () {
-
-		this.document = this.dialogWindow.document;
-		this.editor = this.plugin.editor;
-
-		this.document.open();
-		var html = this.plugin.editorConfiguration.getDocumentType()
-			+ '<html><head></head><body></body></html>\n';
-		this.document.write(html);
-		this.document.close();
-			// IE needs the stylesheets to be loaded before we create the form
-		if (HTMLArea.is_ie) {
-			this.loadStyle();
-		}
-		var head = this.document.getElementsByTagName("head")[0];
-		var title = this.document.getElementsByTagName("title")[0];
-		if (!title) {
-			var title = this.document.createElement("title");
-			head.appendChild(title);
-		}
-		this.document.title = this.arguments.title;
-		var body = this.document.body;
-		body.className = "popupwin dialog";
-		body.id = "--HA-body";
-		var content = this.document.createElement("div");
-		content.className = "content";
-		content.id = "content";
-		this.content = content;
-		body.appendChild(content);
-			// Create the form
-			// Localize, resize and initiate capture of events
-		if (HTMLArea.is_ie) {
-				// Catch errors for IE loosing control in case the window is closed while being initialized
-			try {
-				this.arguments.initialize(this);
-				this.initialize(false, false, "noStyle");
-				this.focus();
-			} catch(e) { }
-		} else {
-			this.arguments.initialize(this);
-				// Firefox needs a delay defore we resize
-			this.initialize(false, (HTMLArea.is_gecko && !HTMLArea.is_safari && !HTMLArea.is_opera));
-			this.focus();
-			if (HTMLArea.is_gecko && !HTMLArea.is_safari && !HTMLArea.is_opera) {
-				var self = this;
-				setTimeout( function() { self.resize(); }, 100);
-			}
-		}
-	},
-
-	/**
 	 * Adds OK and Cancel buttons to the dialogue window
 	 *
 	 * @return	void
@@ -3473,7 +4195,6 @@
 			// Resize the dialog window to its contents
 		if (!noResize) this.resize(noResize);
 	},
-
 	/**
 	 * Load the stylesheets in the dialog window
 	 *
@@ -3485,7 +4206,7 @@
 		link.rel = "stylesheet";
 		link.type = "text/css";
 		link.href = HTMLArea.editorCSS;
-		if (link.href.indexOf("http") == -1 && HTMLArea.is_gecko) link.href = _typo3_host_url + link.href;
+		if (link.href.indexOf("http") == -1 && !Ext.isIE) link.href = _typo3_host_url + link.href;
 		head.appendChild(link);
 	},
 
@@ -3536,8 +4257,7 @@
 			var doc = dialogWindow.document;
 			var content = doc.getElementById("content");
 				// As of Google Chrome build 1798, window resizeTo and resizeBy are completely erratic: do nothing
-			if ((HTMLArea.is_gecko && !HTMLArea.is_opera && !HTMLArea.is_safari)
-					|| ((HTMLArea.is_ie || HTMLArea.is_opera || (HTMLArea.is_safari && !HTMLArea.is_chrome)) && content)) {
+			if (Ext.isGecko || ((Ext.isIE || Ext.isOpera || (Ext.isWebKit && !Ext.isChrome)) && content)) {
 				var self = this;
 				setTimeout( function() {
 					if (!noResize) {
@@ -3551,7 +4271,7 @@
 				}, 75);
 			} else if (!noResize) {
 				var body = doc.body;
-				if (HTMLArea.is_ie) {
+				if (Ext.isIE) {
 					var innerX = (doc.documentElement && doc.documentElement.clientWidth) ? doc.documentElement.clientWidth : body.clientWidth;
 					var innerY = (doc.documentElement && doc.documentElement.clientHeight) ? doc.documentElement.clientHeight : body.clientHeight;
 					var pageY = Math.max(body.scrollHeight, body.offsetHeight);
@@ -3561,7 +4281,7 @@
 						dialogWindow.resizeBy((innerX < body.scrollWidth) ? (Math.max(body.scrollWidth, body.offsetWidth) - innerX) : 0, (body.scrollHeight - body.offsetHeight));
 					}
 					// As of Google Chrome build 1798, window resizeTo and resizeBy are completely erratic: do nothing
-				} else if ((HTMLArea.is_safari && !HTMLArea.is_chrome) || HTMLArea.is_opera) {
+				} else if (Ext.isSafari || Ext.isOpera) {
 					dialogWindow.resizeTo(dialogWindow.innerWidth, body.offsetHeight + 10);
 					if (dialogWindow.innerHeight < body.scrollHeight) {
 						dialogWindow.resizeBy(0, (body.scrollHeight - dialogWindow.innerHeight) + 10);
@@ -3592,8 +4312,8 @@
 
 		var contentWidth = content.offsetWidth;
 		var contentHeight = content.offsetHeight;
-		if (HTMLArea.is_gecko && !HTMLArea.is_opera) {
-			dialogWindow.resizeTo(contentWidth, contentHeight + (HTMLArea.is_safari ? 40 : (HTMLArea.is_ff2 ? 75 : 95)));
+		if (Ext.isGecko || Ext.isWebKit) {
+			dialogWindow.resizeTo(contentWidth, contentHeight + (Ext.isWebKit ? 40 : (Ext.isGecko2 ? 75 : 95)));
 		} else {
 			dialogWindow.resizeTo(contentWidth + 200, contentHeight + 200);
 			if (dialogWindow.innerWidth) {
@@ -3622,7 +4342,7 @@
 			var doc = dialogWindow.document;
 			var body = doc.body;
 				// Center on parent if allowed
-			if (HTMLArea.is_gecko) {
+			if (!Ext.isIE) {
 				var x = dialogWindow.opener.screenX + (dialogWindow.opener.outerWidth - dialogWindow.outerWidth) / 2;
 				var y = dialogWindow.opener.screenY + (dialogWindow.opener.outerHeight - dialogWindow.outerHeight) / 2;
 			} else {
@@ -3632,7 +4352,7 @@
 				var y = (screen.availHeight - H) / 2;
 			}
 				// As of build 1798, Google Chrome moveTo breaks the window dimensions: do nothing
-			if (!HTMLArea.is_chrome) {
+			if (!Ext.isChrome) {
 				try {
 					dialogWindow.moveTo(x, y);
 				} catch(e) { }
@@ -3661,22 +4381,7 @@
 			this.dialogWindow.focus();
 		}
 	},
-
 	/**
-	 * Recover focus from the parent window
-	 *
-	 * @return	void
-	 */
-	recoverFocus : function(ev) {
-		if (this.dialogWindow && !this.dialogWindow.closed) {
-			if (!ev) var ev = window.event;
-			HTMLArea._stopEvent(ev);
-			this.focus();
-		}
-		return false;
-	},
-
-	/**
 	 * Close the dialog window
 	 *
 	 * @return	void
@@ -3688,11 +4393,10 @@
 					this.dialogWindow.openedDialog.close();
 				}
 			} catch(e) { }
-			this.releaseEvents();
 			HTMLArea.Dialog[this.plugin.name] = null;
 			if (!this.dialogWindow.closed) {
 				this.dialogWindow.dialog = null;
-				if (HTMLArea.is_safari || HTMLArea.is_ie) {
+				if (Ext.isWebKit || Ext.isIE) {
 					this.dialogWindow.blur();
 				}
 				this.dialogWindow.close();
@@ -3703,7 +4407,7 @@
 			}
 				// Opera unload event may be triggered after the editor iframe is gone
 			if (this.plugin.editor._iframe) {
-				this.plugin.editor.updateToolbar();
+				this.plugin.editor.toolbar.update();
 			}
 		}
 		return false;
@@ -3729,10 +4433,10 @@
 	 *
 	 * @return	boolean		false if the event was handled
 	 */
-	closeOnEscape : function(ev) {
-		if (!ev) var ev = window.event;
+	closeOnEscape : function(event) {
+		var ev = event.browserEvent;
 		if (ev.keyCode == 27) {
-			if (HTMLArea.is_gecko) {
+			if (!Ext.isIE) {
 				var parentWindow = ev.currentTarget.defaultView;
 			} else {
 				var parentWindow = ev.srcElement.parentNode.parentNode.parentWindow;
@@ -3750,81 +4454,21 @@
 		}
 		return true;
 	},
-
 	/**
-	 * Capture unload, escape and focus events
+	 * Capture unload and escape events
 	 *
 	 * @return	void
 	 */
 	captureEvents : function (skipUnload) {
-			// Capture unload events on the dialogue window, the opener window and the editor frame
-		this.unloadFunctionReference = this.makeFunctionReference("close");
-		HTMLArea._addEvent(this.dialogWindow.opener, "unload", this.unloadFunctionReference);
-		if (HTMLArea.is_gecko && this.plugin.editor._iframe.contentWindow) {
-			HTMLArea._addEvent(this.plugin.editor._iframe.contentWindow, "unload", this.unloadFunctionReference);
+			// Capture unload events on the dialogue window and the editor frame
+		if (!Ext.isIE && this.plugin.editor._iframe.contentWindow) {
+			Ext.EventManager.on(this.plugin.editor._iframe.contentWindow, 'unload', this.close, this, {single: true});
 		}
-		if (!skipUnload) HTMLArea._addEvent(this.dialogWindow, "unload", this.unloadFunctionReference);
+		if (!skipUnload) {
+			Ext.EventManager.on(this.dialogWindow, 'unload', this.close, this, {single: true});
+		}
 			// Capture escape key on the dialogue window
-		this.escapeFunctionReference = this.makeFunctionReference("closeOnEscape");
-		HTMLArea._addEvent(this.dialogWindow.document, "keypress", this.escapeFunctionReference);
-			// Capture focus events on the opener window and its frames
-		this.recoverFocusFunctionReference = this.makeFunctionReference("recoverFocus");
-		this.captureFocus(this.dialogWindow.opener);
-	 },
-
-	/**
-	 * Capture focus events
-	 *
-	 * @return	void
-	 */
-	captureFocus : function (w) {
-		if (HTMLArea.is_gecko) {
-			w.addEventListener("focus", this.recoverFocusFunctionReference, true);
-		} else {
-			HTMLArea._addEvent(w, "focus", this.recoverFocusFunctionReference);
-		}
-		for (var i = w.frames.length; --i >= 0;) {
-			this.captureFocus(w.frames[i]);
-		}
-	},
-
-	/**
-	 * Release all event handlers that were set when the dialogue window was opened
-	 *
-	 * @return	void
-	 */
-	releaseEvents : function() {
-		if (this.dialogWindow) {
-			HTMLArea._removeEvent(this.dialogWindow, "unload", this.unloadFunctionReference);
-			try {
-				if (this.dialogWindow.document) {
-					HTMLArea._removeEvent(this.dialogWindow.document, "keypress", this.escapeFunctionReference);
-				}
-			} catch(e) { }
-			try {
-				if (this.dialogWindow.opener && !this.dialogWindow.opener.closed) {
-					HTMLArea._removeEvent(this.dialogWindow.opener, "unload", this.unloadFunctionReference);
-					if (HTMLArea.is_gecko) {
-						this.releaseFocus(this.dialogWindow.opener);
-					}
-				}
-			} catch(e) { }
-		}
-		if ((HTMLArea.is_gecko && !HTMLArea.is_opera) && this.plugin.editor._iframe.contentWindow) {
-			HTMLArea._removeEvent(this.plugin.editor._iframe.contentWindow, "unload", this.unloadFunctionReference);
-		}
-	},
-
-	/**
-	 * Release focus capturing events that were set when the dialogue window was opened
-	 *
-	 * @return	void
-	 */
-	releaseFocus : function(w) {
-		HTMLArea._removeEvent(w, "focus", this.recoverFocusFunctionReference);
-		for (var i = w.frames.length; --i >= 0;) {
-			this.releaseFocus(w.frames[i]);
-		}
-	}
+		Ext.EventManager.on(this.dialogWindow.document, 'keypress', this.closeOnEscape, this, {single: true});
+	 }
 });
 };
